
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <title>dijkstraK &#8212; K-shortest path direct travellers model  documentation</title>
    <link rel="stylesheet" href="_static/alabaster.css" type="text/css" />
    <link rel="stylesheet" href="_static/pygments.css" type="text/css" />
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    './',
        VERSION:     '',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true,
        SOURCELINK_SUFFIX: '.txt'
      };
    </script>
    <script type="text/javascript" src="_static/jquery.js"></script>
    <script type="text/javascript" src="_static/underscore.js"></script>
    <script type="text/javascript" src="_static/doctools.js"></script>
    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" />
    <link rel="next" title="KSPDTM" href="KSPDTM.html" />
    <link rel="prev" title="Introduction" href="Introduction.html" />
   
  <link rel="stylesheet" href="_static/custom.css" type="text/css" />
  
  
  <meta name="viewport" content="width=device-width, initial-scale=0.9, maximum-scale=0.9" />

  </head>
  <body>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="dijkstrak">
<h1>dijkstraK<a class="headerlink" href="#dijkstrak" title="Permalink to this headline">¶</a></h1>
<p>K-shortest paths search function.</p>
<div class="section" id="definition">
<h2>Definition<a class="headerlink" href="#definition" title="Permalink to this headline">¶</a></h2>
<p><code class="docutils literal"><span class="pre">dijkstraK(s,k,G)</span></code></p>
<div class="line-block">
<div class="line"><br /></div>
</div>
<dl class="docutils">
<dt><strong>Parameters</strong>:</dt>
<dd><ul class="first last simple">
<li><strong>s</strong> (type of elements of <strong>G</strong>) Source node.</li>
<li><strong>k</strong> (int) Parameter <em>k</em> indicating the number of shortest paths
to return for each node.</li>
<li><strong>G</strong> (dictionary) Positively weighted graph represented as dictionary of dictionaries (see below)</li>
</ul>
</dd>
<dt><strong>Returns</strong>:</dt>
<dd><ul class="first last simple">
<li><dl class="first docutils">
<dt><strong>SK</strong> (list) List of k-shortest paths from <strong>s</strong> to every other node in <strong>G</strong>.Each element of this</dt>
<dd>list is a list with two elements: the second is a path represented as a list of nodes.
The first is the length of the path.</dd>
</dl>
</li>
</ul>
</dd>
</dl>
</div>
<div class="section" id="details">
<h2>Details<a class="headerlink" href="#details" title="Permalink to this headline">¶</a></h2>
<p><code class="docutils literal"><span class="pre">dijkstraK</span></code> uses the Dijkstra algorithm to find the k-shortest paths from a node <strong>s</strong> to every
other node of a positively weighted graph <strong>G</strong>. The graph is represented as dictionary whose keys are the nodes of <strong>G</strong>;
the value of each key <strong>u</strong> is a dictionary containing the out-neighbours of <strong>u</strong> as keys, and the weight on their out-link
as the respective values.</p>
<p>For example, the graph in the figure:</p>
<a class="reference internal image-reference" href="_images/toygraph.png"><img alt="toygraph.png" class="align-center" src="_images/toygraph.png" style="width: 319.5px; height: 319.5px;" /></a>
<p>is represented as:</p>
<div class="highlight-default"><div class="highlight"><pre><span></span><span class="n">G</span> <span class="o">=</span> <span class="p">{</span><span class="s1">&#39;1&#39;</span><span class="p">:</span> <span class="p">{</span><span class="s1">&#39;3&#39;</span><span class="p">:</span> <span class="mf">5.0</span><span class="p">},</span> <span class="s1">&#39;2&#39;</span><span class="p">:</span> <span class="p">{</span><span class="s1">&#39;3&#39;</span><span class="p">:</span> <span class="mf">3.0</span><span class="p">},</span> <span class="s1">&#39;3&#39;</span><span class="p">:</span> <span class="p">{</span><span class="s1">&#39;1&#39;</span><span class="p">:</span> <span class="mf">5.0</span><span class="p">,</span> <span class="s1">&#39;2&#39;</span><span class="p">:</span> <span class="mf">3.0</span><span class="p">,</span>
<span class="s1">&#39;4&#39;</span><span class="p">:</span> <span class="mf">4.0</span><span class="p">,</span> <span class="s1">&#39;6&#39;</span><span class="p">:</span> <span class="mf">1.0</span><span class="p">},</span> <span class="s1">&#39;4&#39;</span><span class="p">:</span> <span class="p">{</span><span class="s1">&#39;3&#39;</span><span class="p">:</span> <span class="mf">4.0</span><span class="p">,</span> <span class="s1">&#39;5&#39;</span><span class="p">:</span> <span class="mf">3.0</span><span class="p">},</span> <span class="s1">&#39;5&#39;</span><span class="p">:</span> <span class="p">{</span><span class="s1">&#39;4&#39;</span><span class="p">:</span> <span class="mf">3.0</span><span class="p">,</span>
<span class="s1">&#39;6&#39;</span><span class="p">:</span> <span class="mf">2.0</span><span class="p">},</span> <span class="s1">&#39;6&#39;</span><span class="p">:</span> <span class="p">{</span><span class="s1">&#39;3&#39;</span><span class="p">:</span> <span class="mf">1.0</span><span class="p">,</span> <span class="s1">&#39;5&#39;</span><span class="p">:</span> <span class="mf">2.0</span><span class="p">,</span> <span class="s1">&#39;7&#39;</span><span class="p">:</span> <span class="mf">4.0</span><span class="p">,</span> <span class="s1">&#39;8&#39;</span><span class="p">:</span> <span class="mf">6.0</span><span class="p">},</span> <span class="s1">&#39;7&#39;</span><span class="p">:</span>
<span class="p">{</span><span class="s1">&#39;6&#39;</span><span class="p">:</span> <span class="mf">4.0</span><span class="p">},</span><span class="s1">&#39;8&#39;</span><span class="p">:</span> <span class="p">{</span><span class="s1">&#39;6&#39;</span><span class="p">:</span> <span class="mf">6.0</span><span class="p">}}</span>
</pre></div>
</div>
<p>This representation works for directed graphs. For undirected graphs, it is sufficient to include
both edges (<em>u</em>, <em>v</em> ) and (<em>v</em>, <em>u</em> ) (with the same weight) for every pair of nodes <em>u</em> and <em>v</em>.</p>
</div>
<div class="section" id="examples">
<h2>Examples<a class="headerlink" href="#examples" title="Permalink to this headline">¶</a></h2>
<p>By calling the function <code class="docutils literal"><span class="pre">dijkstraK('1',2,G)</span></code> on the graph in the picture, we obtain the 2 shortest paths
from node ‘1’ to the other 7 nodes:</p>
<div class="highlight-default"><div class="highlight"><pre><span></span><span class="p">[[</span><span class="mf">5.0</span><span class="p">,</span> <span class="p">[</span><span class="s1">&#39;1&#39;</span><span class="p">,</span> <span class="s1">&#39;3&#39;</span><span class="p">]],</span> <span class="p">[</span><span class="mf">6.0</span><span class="p">,</span> <span class="p">[</span><span class="s1">&#39;1&#39;</span><span class="p">,</span> <span class="s1">&#39;3&#39;</span><span class="p">,</span> <span class="s1">&#39;6&#39;</span><span class="p">]],</span> <span class="p">[</span><span class="mf">8.0</span><span class="p">,</span> <span class="p">[</span><span class="s1">&#39;1&#39;</span><span class="p">,</span> <span class="s1">&#39;3&#39;</span><span class="p">,</span> <span class="s1">&#39;2&#39;</span><span class="p">]],</span> <span class="p">[</span><span class="mf">8.0</span><span class="p">,</span> <span class="p">[</span><span class="s1">&#39;1&#39;</span><span class="p">,</span> <span class="s1">&#39;3&#39;</span><span class="p">,</span> <span class="s1">&#39;6&#39;</span><span class="p">,</span> <span class="s1">&#39;5&#39;</span><span class="p">]],</span>
<span class="p">[</span><span class="mf">9.0</span><span class="p">,</span> <span class="p">[</span><span class="s1">&#39;1&#39;</span><span class="p">,</span> <span class="s1">&#39;3&#39;</span><span class="p">,</span> <span class="s1">&#39;4&#39;</span><span class="p">]],</span> <span class="p">[</span><span class="mf">10.0</span><span class="p">,</span> <span class="p">[</span><span class="s1">&#39;1&#39;</span><span class="p">,</span> <span class="s1">&#39;3&#39;</span><span class="p">,</span> <span class="s1">&#39;6&#39;</span><span class="p">,</span> <span class="s1">&#39;7&#39;</span><span class="p">]],</span> <span class="p">[</span><span class="mf">11.0</span><span class="p">,</span> <span class="p">[</span><span class="s1">&#39;1&#39;</span><span class="p">,</span> <span class="s1">&#39;3&#39;</span><span class="p">,</span> <span class="s1">&#39;6&#39;</span><span class="p">,</span> <span class="s1">&#39;5&#39;</span><span class="p">,</span> <span class="s1">&#39;4&#39;</span><span class="p">]],</span>
<span class="p">[</span><span class="mf">12.0</span><span class="p">,</span> <span class="p">[</span><span class="s1">&#39;1&#39;</span><span class="p">,</span> <span class="s1">&#39;3&#39;</span><span class="p">,</span> <span class="s1">&#39;4&#39;</span><span class="p">,</span> <span class="s1">&#39;5&#39;</span><span class="p">]],</span> <span class="p">[</span><span class="mf">12.0</span><span class="p">,</span> <span class="p">[</span><span class="s1">&#39;1&#39;</span><span class="p">,</span> <span class="s1">&#39;3&#39;</span><span class="p">,</span> <span class="s1">&#39;6&#39;</span><span class="p">,</span> <span class="s1">&#39;8&#39;</span><span class="p">]],</span> <span class="p">[</span><span class="mf">14.0</span><span class="p">,</span> <span class="p">[</span><span class="s1">&#39;1&#39;</span><span class="p">,</span> <span class="s1">&#39;3&#39;</span><span class="p">,</span> <span class="s1">&#39;4&#39;</span><span class="p">,</span> <span class="s1">&#39;5&#39;</span><span class="p">,</span> <span class="s1">&#39;6&#39;</span><span class="p">]],</span>
<span class="p">[</span><span class="mf">18.0</span><span class="p">,</span> <span class="p">[</span><span class="s1">&#39;1&#39;</span><span class="p">,</span> <span class="s1">&#39;3&#39;</span><span class="p">,</span> <span class="s1">&#39;4&#39;</span><span class="p">,</span> <span class="s1">&#39;5&#39;</span><span class="p">,</span> <span class="s1">&#39;6&#39;</span><span class="p">,</span> <span class="s1">&#39;7&#39;</span><span class="p">]],</span> <span class="p">[</span><span class="mf">20.0</span><span class="p">,</span> <span class="p">[</span><span class="s1">&#39;1&#39;</span><span class="p">,</span> <span class="s1">&#39;3&#39;</span><span class="p">,</span> <span class="s1">&#39;4&#39;</span><span class="p">,</span> <span class="s1">&#39;5&#39;</span><span class="p">,</span> <span class="s1">&#39;6&#39;</span><span class="p">,</span> <span class="s1">&#39;8&#39;</span><span class="p">]]]</span>
</pre></div>
</div>
<p>From this output we can obtain, for example, the 2 shortest paths from node ‘1’ to node ‘5’.</p>
<a class="reference internal image-reference" href="_images/toygraphSP.png"><img alt="toygraph.png" src="_images/toygraphSP.png" style="width: 45%;" /></a>
<a class="reference internal image-reference" href="_images/toysecond.png"><img alt="toygraph.png" src="_images/toysecond.png" style="width: 45%;" /></a>
</div>
</div>


          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<h1 class="logo"><a href="index.html">K-shortest path direct travellers model</a></h1>








<h3>Navigation</h3>
<p class="caption"><span class="caption-text">Contents:</span></p>
<ul class="current">
<li class="toctree-l1"><a class="reference internal" href="Introduction.html">Introduction</a></li>
<li class="toctree-l1 current"><a class="current reference internal" href="#">dijkstraK</a><ul>
<li class="toctree-l2"><a class="reference internal" href="#definition">Definition</a></li>
<li class="toctree-l2"><a class="reference internal" href="#details">Details</a></li>
<li class="toctree-l2"><a class="reference internal" href="#examples">Examples</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="KSPDTM.html">KSPDTM</a></li>
</ul>

<div class="relations">
<h3>Related Topics</h3>
<ul>
  <li><a href="index.html">Documentation overview</a><ul>
      <li>Previous: <a href="Introduction.html" title="previous chapter">Introduction</a></li>
      <li>Next: <a href="KSPDTM.html" title="next chapter">KSPDTM</a></li>
  </ul></li>
</ul>
</div>
<div id="searchbox" style="display: none" role="search">
  <h3>Quick search</h3>
    <form class="search" action="search.html" method="get">
      <div><input type="text" name="q" /></div>
      <div><input type="submit" value="Go" /></div>
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="footer">
      &copy;2018, Armando Guardasole.
      
      |
      Powered by <a href="http://sphinx-doc.org/">Sphinx 1.6.3</a>
      &amp; <a href="https://github.com/bitprophet/alabaster">Alabaster 0.7.10</a>
      
      |
      <a href="_sources/dijkstraK.rst.txt"
          rel="nofollow">Page source</a>
    </div>

    

    
  </body>
</html>